#pragma once

#include "FWatchCore2Obj.hpp"

typedef CComPtr<IFileInfo> IFileInfoPtr;

class FileInfoMap : public CAtlMap<CComBSTR, IFileInfoPtr>
{
public:
};

class __declspec(uuid("F571804D-AED6-4e82-BE42-65DB3AD5759A")) CFileInfoCollection
	: public IFileInfoCollection
	, public IFileInfoReceiver
	, public IFileInfoCollectionComparable
	, public CComObjectRoot
	, public CComCoClass<CFileInfoCollection>
{
public:
	friend class CFileInfoEnumerator;

	DECLARE_OBJECT_DESCRIPTION("CFileInfoCollection")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	BEGIN_COM_MAP(CFileInfoCollection)
		COM_INTERFACE_ENTRY(IFileInfoCollection)
		COM_INTERFACE_ENTRY(IFileInfoReceiver)
		COM_INTERFACE_ENTRY(IFileInfoCollectionComparable)
	END_COM_MAP()

	/// PRIVATE

	HRESULT FinalConstruct() throw();

	/// IFileInfoCollection

	HRESULT __stdcall get_Length(ULONG* v_pLength) throw();

	HRESULT __stdcall new_Enum(IFileInfoEnumerator** v_ppFileInfoEnumerator) throw();

	HRESULT __stdcall get_Item(LPCWSTR v_pName, IFileInfo** v_ppFindData) throw();

	HRESULT __stdcall set_Item(LPCWSTR v_pName, IFileInfo* v_pFileInfo) throw();

	HRESULT __stdcall remove_Item(LPCWSTR v_pName) throw();

	HRESULT __stdcall Clear() throw();

	HRESULT __stdcall Clone(IFileInfoCollection** v_ppClone) throw();

	/// IFileInfoReceiver

	HRESULT __stdcall ReceiveFileInfo(LPCWSTR v_pPath, IFileInfo* v_pFileInfo) throw();

	/// IFileInfoCollectionComparable

	HRESULT __stdcall Compare(IFileInfoCollection* v_pFileInfoCollection, IFileInfoComparator* v_pComparator) throw();

	HRESULT __stdcall CompareAllItems(IFileInfoCollection* v_pFileInfoCollection, IFileInfoComparator* v_pComparator) throw();

private:

	/**
	 * OƃrbgtÕ}bvB
	 */
	typedef CAtlMap<CComBSTR, DWORD> ItemExistsMap;

	/**
	 * 2̃RNVׂ̂Ă̖OItemExistsMapɊi[܂B
	 * l̃rbgtOƂȂ܂B
	 * rbg1́ÃRNVێt@C񂪂邱Ƃ܂B
	 * rbg2́ÃRNVێt@C񂪂邱Ƃ܂B
	 */
	HRESULT MakeItemExistsMap(ItemExistsMap& v_itemExistsMap, IFileInfoCollection* v_pFileInfoCollection) throw();

	/**
	 * RNV̔rs܂B
	 * v_fastTerminatefalsȅꍇ́AׂĂ̗vfr܂B
	 * truȅꍇ͗vf̔rS_OKȊOԂꂽ_ŁAsvm肷邽߁A𑁊ɏI܂B
	 * @param v_pFileInfoCollection r鑊̃RNV
	 * @param v_pComparator r
	 * @param v_fastTerminate r킪S_OKȊOԂ瑁ɏI邱ƂtO
	 * @return vS_OKAvȂS_FALSEAG[Ȃ΃G[R[h
	 */
	HRESULT Compare0(IFileInfoCollection* v_pFileInfoCollection, IFileInfoComparator* v_pComparator, bool v_fastTerminate) throw();

	/**
	 * t@Cێ}bv
	 */
	FileInfoMap fileInfoMap_;

	/**
	 * }bvύX邽тɃJEgAbvo[W
	 */
	ULONG version_;
};

class __declspec(uuid("F1AFE36B-C50E-4282-99E1-2F5B0645EF78")) CFileInfoEnumerator
	: public IFileInfoEnumerator
	, public CComObjectRoot
	, public CComCoClass<CFileInfoEnumerator>
{
public:
	DECLARE_OBJECT_DESCRIPTION("CFileInfoEnumerator")
	DECLARE_CLASSFACTORY()
	DECLARE_NO_REGISTRY()

	BEGIN_COM_MAP(CFileInfoEnumerator)
		COM_INTERFACE_ENTRY(IFileInfoEnumerator)
	END_COM_MAP()

	/// PRIVATE

	HRESULT FinalConstruct() throw();

	HRESULT Init(CFileInfoCollection* v_pParent) throw();

	/// IFileInfoEnumerator

	HRESULT __stdcall Reset() throw();

	HRESULT __stdcall HasNext() throw();

	HRESULT __stdcall Next(BSTR* v_pName, IFileInfo** v_ppFindData) throw();

private:

	/**
	 * eRNṼo[WɕύXȂƂmFB
	 */
	HRESULT CheckVersion() const throw();

	/**
	 * Ce[^̃tO
	 */
	POSITION pos_;

	/**
	 * Ce[^\z̐eRNṼo[W
	 */
	ULONG version_;

	/**
	 * eRNV
	 */
	CFileInfoCollection* pParent_;
};
